VERSION 5.00
Begin VB.Form frmStartup 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Report Creation Example"
   ClientHeight    =   5400
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   6660
   Icon            =   "frmStartup.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   5400
   ScaleWidth      =   6660
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdCancel 
      Cancel          =   -1  'True
      Caption         =   "Cancel"
      Height          =   495
      Left            =   4680
      TabIndex        =   6
      Top             =   4200
      Width           =   1215
   End
   Begin VB.CommandButton cmdSave 
      Caption         =   "&Save"
      Enabled         =   0   'False
      Height          =   495
      Left            =   2760
      TabIndex        =   5
      Top             =   4200
      Width           =   1215
   End
   Begin VB.CommandButton cmdPreview 
      Caption         =   "&Preview"
      Enabled         =   0   'False
      Height          =   495
      Left            =   840
      TabIndex        =   4
      Top             =   4200
      Width           =   1215
   End
   Begin VB.CommandButton cmdModify 
      Caption         =   "&Modify Report"
      Enabled         =   0   'False
      Height          =   615
      Left            =   2400
      TabIndex        =   3
      Top             =   2640
      Width           =   2175
   End
   Begin VB.CommandButton cmdCreate 
      Caption         =   "Create &New Report Object"
      Height          =   735
      Left            =   2400
      TabIndex        =   2
      Top             =   1200
      Width           =   2175
   End
   Begin VB.Label Label2 
      Alignment       =   2  'Center
      Caption         =   "Run Time Report Creation Example"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   720
      TabIndex        =   1
      Top             =   600
      Width           =   5295
   End
   Begin VB.Label Label1 
      Alignment       =   2  'Center
      Caption         =   "Crystal Report Designer Component"
      BeginProperty Font 
         Name            =   "Arial"
         Size            =   15.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H8000000D&
      Height          =   495
      Left            =   840
      TabIndex        =   0
      Top             =   120
      Width           =   5055
   End
End
Attribute VB_Name = "frmStartup"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Dim ADOConnection As ADODB.Connection
Dim ADOCommand As ADODB.Command
Private Sub cmdCancel_Click()
    Unload Me
End Sub

Private Sub cmdCreate_Click()
    'will throw a 91 error if object not set
    On Error Resume Next
    Debug.Print Report.RecordSelectionFormula
    If Err.Number = 91 Then
        GoTo CreateReport
    ElseIf Err.Number = 0 Then
        If MsgBox("A report object already exists." & vbCrLf & "Are you sure you want to replace it with a new object?", vbYesNo + vbQuestion) = vbNo Then Exit Sub
    Else
        MsgBox "Error in cmdCreate_Click: " & Err.Number & " - " & Err.Description
        Exit Sub
    End If  'Err.Number = 91
    

CreateReport:
    On Error GoTo 0 'you'll want to re-enable error handling with a production app
    Screen.MousePointer = vbHourglass
    ' Create a new empty report
    Set Report = Nothing
    Set Report = Application.NewReport
   
    ' Open the data connection
    Set ADOConnection = New ADODB.Connection
    ADOConnection.Open "Provider=MSDASQL;Persist Security Info=False;Data Source=Xtreme Sample Database 11;Mode=Read"

    ' Create a new instance of an ADO command object
    Set ADOCommand = New ADODB.Command
    Set ADOCommand.ActiveConnection = ADOConnection
    ADOCommand.CommandText = "Orders"
    ADOCommand.CommandType = adCmdTable

    ' Add the datasource (the XTREME Orders Table) to the report
    Report.Database.AddADOCommand ADOConnection, ADOCommand

    ' Add report title
    Dim ReportTitle As CRAXDDRT.TextObject
    Set ReportTitle = Report.Sections(1).AddTextObject("FedEx Order Detail", 6000, 400)
    
    ' Format the title
    With ReportTitle
        .HorAlignment = crHorCenterAlign
        .LeftLineStyle = crLSSingleLine
        .RightLineStyle = crLSSingleLine
        .TopLineStyle = crLSSingleLine
        .BottomLineStyle = crLSSingleLine
        .HasDropShadow = True
        .Font.Size = 18
        .Font.Bold = True
        .TextColor = &H808000
        .Height = 500
        .Width = 4500
    End With

    ' Add fields to details section
    ' Note that the Sections collection can be accessed via number or string index
    Report.Sections("D").AddFieldObject "{ado.Order ID}", 750, 5
    Report.Sections("D").AddFieldObject "{ado.Order Date}", 3150, 5
    Report.Sections("D").AddFieldObject "{ado.Order Amount}", 5500, 5
    Report.Sections("D").AddFieldObject "{ado.Ship Via}", 8850, 5

    ' Format the Order Amount to have one dollar sign per page
    Report.Sections(3).ReportObjects(3).UseOneSymbolPerPage = True

    ' Create and format Order Amount Grand Total in report footer
    Dim AmountTotal As CRAXDDRT.FieldObject
    ' Creating a separate object variable avoids deep navigation down the hierarchy when formatting
    Set AmountTotal = Report.Sections(4).AddSummaryFieldObject _
    (Report.Sections(3).ReportObjects(3).Field.Name, crSTSum, 6000, 750)
    With AmountTotal
        .Width = 1500
        .Font.Bold = True
    End With    'AmountTotal

    Report.RecordSelectionFormula = "{ado.Ship Via} = 'FedEx'"

    cmdModify.Enabled = True
    cmdPreview.Enabled = True
    cmdSave.Enabled = True
    
    Screen.MousePointer = vbDefault
    MsgBox "New Report Object created", vbInformation
    
End Sub

Private Sub cmdModify_Click()
  frmDesigner.Show vbModal
End Sub

Private Sub cmdPreview_Click()
    frmViewer.Show vbModal
End Sub

Private Sub cmdSave_Click()
    Report.SaveAs App.Path & "\Sample.RPT", cr80FileFormat
    MsgBox "Report has been saved as Sample.RPT in" & vbCrLf & App.Path, vbInformation
End Sub

Private Sub Form_Load()
    Set Application = New CRAXDDRT.Application
    optWizard = True
End Sub

Private Sub Form_Unload(Cancel As Integer)
    Set ADOConnection = Nothing
    Set ADOCommand = Nothing
    Set CRWizard = Nothing
    Set ReportTitle = Nothing
    Set Report = Nothing
    Set Application = Nothing
End Sub
